/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;
using SIPSorcery.SIP;

namespace SeriousSIP.Model
{
    [DataContract]
    public partial class MessageInfoParams :  IEquatable<MessageInfoParams>, IValidatableObject
    {
        public MessageInfoParams(string id = default(string), string from = default(string), string to = default(string),
            SIPCallDirection direction = SIPCallDirection.None, string message = default(string))
        {
            this.Id = id;
            this.From = from;
            this.To = to;
            this.Direction = direction;
            this.Message = message;
        }
        
        /// <summary>
        /// Gets or Sets OnCallPlayDone
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayFilesDone
        /// </summary>
        [DataMember(Name="from", EmitDefaultValue=false)]
        public string From { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }

        /// <summary>
        /// Gets or Sets OnCallSendDigitsDone
        /// </summary>
        [DataMember(Name="direction", EmitDefaultValue=false)]
        public SIPCallDirection Direction { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPlayRecordDone
        /// </summary>
        [DataMember(Name = "message", EmitDefaultValue = false)]
        public string Message { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CallInfoParams {\n");
            sb.Append("  id: ").Append(Id).Append("\n");
            sb.Append("  from: ").Append(From).Append("\n");
            sb.Append("  to: ").Append(To).Append("\n");
            sb.Append("  direction: ").Append(Direction).Append("\n");
            sb.Append("  message: ").Append(Message).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as MessageInfoParams);
        }

        /// <summary>
        /// Returns true if CallMediaSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of CallMediaSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MessageInfoParams input)
        {
            if (input == null)
                return false;

            return true;
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
               
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
